"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _toConsumableArray2 = _interopRequireDefault(
  require("reshow-runtime/helpers/toConsumableArray")
);

var _reshowFluxBase = require("reshow-flux-base");

var _realTimeStore = require("./stores/realTimeStore.js");

var _messageStore = require("./stores/messageStore.js");

var _clientStorageStore = require("./stores/clientStorageStore.js");

var _pageStore = require("./stores/pageStore.js");

var dispatch = function dispatch() {
  for (
    var _len = arguments.length, action = new Array(_len), _key = 0;
    _key < _len;
    _key++
  ) {
    action[_key] = arguments[_key];
  }

  action = _reshowFluxBase.refineAction.apply(
    void 0,
    (0, _toConsumableArray2["default"])(action)
  );

  switch (action.type) {
    case "dialog/start":
    case "dialog/end":
    case "alert/reset":
    case "alert/del":
    case "alert/add":
      (0, _messageStore.messageDispatch)(action);
      break;

    case "realTime":
      (0, _realTimeStore.realTimeDispatch)(action);
      break;

    case "local":
      (0, _clientStorageStore.localStorageDispatch)(action.params);
      break;

    case "localValue":
      (0, _clientStorageStore.localValueDispatch)(action.params);
      break;

    case "session":
      (0, _clientStorageStore.sessionStorageDispatch)(action.params);
      break;

    case "sessionValue":
      (0, _clientStorageStore.sessionValueDispatch)(action.params);
      break;

    default:
      (0, _pageStore.pageDispatch)(action);
      break;
  }
};

var _default = dispatch;
exports["default"] = _default;
module.exports = exports.default;
