"use strict";

exports.__esModule = true;
exports.useSessionValue =
  exports.useSessionStorage =
  exports.useLocalValue =
  exports.useLocalStorage =
    void 0;

var _reshowReturn = require("reshow-return");

var _clientStorageStore = require("../stores/clientStorageStore.js");

var getUseStorage = function getUseStorage(store, dispatch) {
  return function (initStates) {
    var state = (0, _reshowReturn.useClientReturn)(initStates, store);
    return [state, dispatch];
  };
};

var useLocalStorage = getUseStorage(
  _clientStorageStore.localStorageStore,
  _clientStorageStore.localStorageDispatch
);
exports.useLocalStorage = useLocalStorage;
var useLocalValue = getUseStorage(
  _clientStorageStore.localValueStore,
  _clientStorageStore.localValueDispatch
);
exports.useLocalValue = useLocalValue;
var useSessionStorage = getUseStorage(
  _clientStorageStore.sessionStorageStore,
  _clientStorageStore.sessionStorageDispatch
);
exports.useSessionStorage = useSessionStorage;
var useSessionValue = getUseStorage(
  _clientStorageStore.sessionValueStore,
  _clientStorageStore.sessionValueDispatch
);
exports.useSessionValue = useSessionValue;
