"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(
  require("reshow-runtime/helpers/objectSpread2")
);

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(
  require("reshow-runtime/helpers/objectWithoutPropertiesLoose")
);

var _getObjectValue = _interopRequireDefault(require("get-object-value"));

var _reactAtomicMolecule = require("react-atomic-molecule");

var _reshowFlux = require("reshow-flux");

var _ReshowComponent = require("../molecules/ReshowComponent.js");

var _pageStore = _interopRequireDefault(require("../../stores/pageStore.js"));

var _excluded = ["immutable", "children"],
  _excluded2 = ["section"],
  _excluded3 = ["shouldRender"];
var pathStates = _ReshowComponent.connectOptions.pathStates,
  otherOptions = (0, _objectWithoutPropertiesLoose2["default"])(
    _ReshowComponent.connectOptions,
    ["pathStates"]
  );
otherOptions.initStates = ["section", "I18N"];

var Section = function Section(props) {
  var propsImmutable = props.immutable,
    children = props.children,
    otherProps = (0, _objectWithoutPropertiesLoose2["default"])(
      props,
      _excluded
    );

  var _useConnect = (0, _reshowFlux.useConnect)(otherOptions)(props),
    section = _useConnect.section,
    state = (0, _objectWithoutPropertiesLoose2["default"])(
      _useConnect,
      _excluded2
    );

  if (!section || !children) {
    return null;
  }

  var name = props.name;
  var immutable =
    propsImmutable !== null && propsImmutable !== void 0
      ? propsImmutable
      : _pageStore["default"].getState().get("immutable");
  var allParams = (0, _objectSpread2["default"])(
    (0, _objectSpread2["default"])(
      {},
      _ReshowComponent.connectOptions.reset(otherProps)
    ),
    state
  );

  if (immutable) {
    var thisSection = (0, _getObjectValue["default"])(section, [name]);

    if (!thisSection) {
      return null;
    }

    var shouldRender = (0, _getObjectValue["default"])(thisSection, [
      "shouldRender",
    ]);

    if (!shouldRender) {
      return null;
    }

    (0, _reshowFlux.forEachMap)(thisSection, function (v, k) {
      return (allParams[k] = v);
    });
    delete allParams["shouldRender"];
  } else {
    var _get = (0, _getObjectValue["default"])(section, [name], {}),
      _shouldRender = _get.shouldRender,
      others = (0, _objectWithoutPropertiesLoose2["default"])(_get, _excluded3);

    if (!_shouldRender) {
      return null;
    }

    allParams = (0, _objectSpread2["default"])(
      (0, _objectSpread2["default"])({}, others),
      allParams
    );
  }

  var noName = children.every
    ? children.every(function (child) {
        return !(0, _getObjectValue["default"])(child, ["props", "name"]);
      })
    : !(0, _getObjectValue["default"])(children, ["props", "name"]);

  if (!noName) {
    delete allParams["name"];
  }

  return (0, _reactAtomicMolecule.build)(children)(allParams);
};

Section.displayName = "ReshowSection";
var _default = Section;
exports["default"] = _default;
module.exports = exports.default;
