import _toConsumableArray from "reshow-runtime/es/helpers/toConsumableArray";
import { refineAction } from "reshow-flux-base";
import { realTimeDispatch } from "./stores/realTimeStore.mjs";
import { messageDispatch } from "./stores/messageStore.mjs";
import { localStorageDispatch, localValueDispatch, sessionStorageDispatch, sessionValueDispatch } from "./stores/clientStorageStore.mjs";
import { pageDispatch } from "./stores/pageStore.mjs";

var dispatch = function dispatch() {
  for (var _len = arguments.length, action = new Array(_len), _key = 0; _key < _len; _key++) {
    action[_key] = arguments[_key];
  }

  action = refineAction.apply(void 0, _toConsumableArray(action));

  switch (action.type) {
    case "dialog/start":
    case "dialog/end":
    case "alert/reset":
    case "alert/del":
    case "alert/add":
      messageDispatch(action);
      break;

    case "realTime":
      realTimeDispatch(action);
      break;

    case "local":
      localStorageDispatch(action.params);
      break;

    case "localValue":
      localValueDispatch(action.params);
      break;

    case "session":
      sessionStorageDispatch(action.params);
      break;

    case "sessionValue":
      sessionValueDispatch(action.params);
      break;

    default:
      pageDispatch(action);
      break;
  }
};

export default dispatch;