import { useClientReturn } from "reshow-return";
import { localStorageStore, localStorageDispatch, localValueStore, localValueDispatch, sessionStorageStore, sessionStorageDispatch, sessionValueStore, sessionValueDispatch } from "../stores/clientStorageStore.mjs";

var getUseStorage = function getUseStorage(store, dispatch) {
  return function (initStates) {
    var state = useClientReturn(initStates, store);
    return [state, dispatch];
  };
};

var useLocalStorage = getUseStorage(localStorageStore, localStorageDispatch);
var useLocalValue = getUseStorage(localValueStore, localValueDispatch);
var useSessionStorage = getUseStorage(sessionStorageStore, sessionStorageDispatch);
var useSessionValue = getUseStorage(sessionValueStore, sessionValueDispatch);
export { useLocalStorage, useLocalValue, useSessionStorage, useSessionValue };