import _asyncToGenerator from "reshow-runtime/es/helpers/asyncToGenerator";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _assertThisInitialized from "reshow-runtime/es/helpers/assertThisInitialized";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _createSuper from "reshow-runtime/es/helpers/createSuper";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";

var _div, _FakeComponent, _FakeComponent2;

import React, { PureComponent } from "react";
import { expect } from "chai";
import { act, render, cleanIt } from "reshow-unit";
import { globalStore } from "../../../stores/globalStore.mjs";
import { Return, localStorageStore, sessionStorageStore, dispatch } from "../../../index.mjs";
import { jsx as _jsx } from "react/jsx-runtime";

var TestEl = /*#__PURE__*/function (_PureComponent) {
  _inherits(TestEl, _PureComponent);

  var _super = _createSuper(TestEl);

  function TestEl() {
    var _this;

    _classCallCheck(this, TestEl);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "show", 0);

    return _this;
  }

  _createClass(TestEl, [{
    key: "render",
    value: function render() {
      this.show++;
      return _div || (_div = /*#__PURE__*/_jsx("div", {}));
    }
  }]);

  return TestEl;
}(PureComponent);

var uFake;

var FakeComponent = /*#__PURE__*/function (_PureComponent2) {
  _inherits(FakeComponent, _PureComponent2);

  var _super2 = _createSuper(FakeComponent);

  function FakeComponent(props) {
    var _this2;

    _classCallCheck(this, FakeComponent);

    _this2 = _super2.call(this, props);
    uFake = _assertThisInitialized(_this2);
    return _this2;
  }

  _createClass(FakeComponent, [{
    key: "render",
    value: function render() {
      var _this3 = this;

      var {
        storage
      } = this.props;
      return /*#__PURE__*/_jsx(Return, {
        store: storage,
        children: /*#__PURE__*/_jsx(TestEl, {
          ref: function ref(el) {
            return _this3.el = el;
          }
        })
      });
    }
  }]);

  return FakeComponent;
}(PureComponent);

describe("Test Storage Return", function () {
  beforeEach(function () {
    globalStore.path = null;
  });
  afterEach(function () {
    cleanIt();
  });
  it("test get local storage", /*#__PURE__*/_asyncToGenerator(function* () {
    var wrap = render(_FakeComponent || (_FakeComponent = /*#__PURE__*/_jsx(FakeComponent, {
      storage: localStorageStore
    })));
    var uString = "test123";
    yield act(function () {
      return dispatch("local", {
        data: uString
      });
    }, 5);
    expect(uFake.el.props.data).to.equal(uString);
  }));
  it("test get session storage", /*#__PURE__*/_asyncToGenerator(function* () {
    var wrap = render(_FakeComponent2 || (_FakeComponent2 = /*#__PURE__*/_jsx(FakeComponent, {
      storage: sessionStorageStore
    })));
    var uString = "test456";
    yield act(function () {
      return dispatch("session", {
        data: uString
      });
    }, 5);
    expect(uFake.el.props.data).to.equal(uString);
  }));
});